#include <kernel>
#include <thread>
#include <time>

#include <unistd.h>

#ifndef PREEMPTION_RATE
#error PREEMPTION_RATE not defined in makefile
#endif

Duration default_preemption() {
	return PREEMPTION_RATE;
}

static const unsigned long N = 50_000ul;

int main(int argc, char* argv[]) {
	processor * p[15];
	write(STDOUT_FILENO, "Preparing\n", sizeof("Preparing\n"));
	for ( int pi = 0; pi < 15; pi++ ) {
		p[pi] = new();
	}
	write(STDOUT_FILENO, "Starting\n", sizeof("Starting\n"));
	for ( int i = 0; i < N; i++) {
		int pi = i % 15;
		delete( p[pi] );
		p[pi] = new();
	}
	write(STDOUT_FILENO, "Stopping\n", sizeof("Stopping\n"));
	for ( int pi = 0; pi < 15; pi++ ) {
		delete( p[pi] );
	}
	write(STDOUT_FILENO, "Done\n", sizeof("Done\n"));
}
